package lazabs.viewer

import lazabs.ast.ASTree._
import lazabs.cfg._

object DrawGraph {
  val dotFileName =  "DotOutput"
  
  var fileId = 0

  def apply(cfg: Map[CFGVertex,Set[CFGEdge]]): Unit = {
    val runTime = Runtime.getRuntime   
    val dotOutput = new java.io.FileWriter(dotFileName + fileId + ".dot")
    dotOutput.write( "digraph lazabs {\n")
    dotOutput.write( CFGtoDot(cfg) )
    dotOutput.write( "}")
    dotOutput.close
    var proc = runTime.exec( "dot -Tpng " + "DotOutput" + fileId + ".dot" + " -o graph" + fileId + ".png" )
    proc.waitFor
    proc = runTime.exec( "eog graph" + fileId + ".png")
    proc.waitFor
    fileId = fileId + 1
  }
  
  def CFGtoDot(cfg: Map[CFGVertex,Set[CFGEdge]]): String = {
    var dotContent = ""
    cfg.foreach { case (CFGVertex(id),edges) =>
      edges.foreach(e => {
        dotContent += id + "[label=\"" + id + "\"];\n"
        dotContent += id + "->" + e.to.id.toString + "[label=\"" + lazabs.viewer.ScalaPrinter(e.label) + "\"];\n"
      })
    }
    dotContent
  }
}
